%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2016ABKģ Dynare
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% ģеı     %%%%%%%%%%%%%% 

var
%%%%% 
%   13
Y,  K,  L,  M, EX, C,  I, N, D,  Dstar, GDP, Kb, Kh, Omega,
% ۸  
mc, pi,ebar,  w, rk, Q,  rd, R,
% bankֱ  6
x,  Phi,  psi,  nu,  mu,  mud, 
%߱
tauK, taustar,tauN, 
%
Util, welfare,
%%%%% 
A,  Rstar, ystar;

varexo
%%%%% ,Ŷ
e_A,  e_Rstar, e_rd, e_ystar;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% ģв%%%%%%%%%%%%%%%%%%%%%%%%%%
parameters
% bankֲ
theta,  gamma,  sigma, epsilon, 
% ƫü
alphaK, alphaM, alphaL, delta, eta, omega, kappai, phi,kappa,
beta, zeta, zeta0, nh, 
% 
rho_Rstar, rho_A, rho_ystar, std_rd, std_A,  std_Rstar,  std_ystar,  rhoi,  omegapi,
% ߲
omega_tauK, omega_taustar;

%%%%%%%%%% ģвֵ
% bankֲ
sigma=0.94;
theta=0.474910394265250;
gamma=6.399999999999884;
epsilon=5.882352941174504e-04;
% ƫü
alphaK=0.3;
alphaL=0.55;
alphaM=0.15;
beta=1/1.015;
delta=0.02;
eta=9;
omega=0.66;
kappai=1;
zeta=0.2;
zeta0=5.89;
phi=1;
nh=9.849019085822965e-04;
kappa=(eta-1)*omega/((1-omega)*(1-beta*omega));
% 
rho_Rstar=0.95;
std_Rstar=0.00075;
rho_ystar=0.95;
std_ystar=0.003;
std_rd=0.00075;
rho_A=0.95;
std_A=0.003;
rhoi=0.85;
omegapi=1.5;
% ߲
omega_tauK=0.00;
omega_taustar=0.00;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% ģз%%%%%%%%%%%%%%%%%%%%%%%%%% 
model;
%̬
#I_ss=(steady_state(I));
#Rstar_ss=(steady_state(Rstar));
#ystar_ss=(steady_state(ystar));
#rd_ss=(steady_state(rd));

% 2 Ӧԭķ̺
mc=(1/A)*rk^(alphaK)*ebar^(alphaM)*w^(alphaL);
% 3
(pi-1)*pi=(1/kappa)*(eta*mc+1-eta)+beta*(C-zeta0*L^(1+zeta)/(1+zeta) )/(C(+1)-zeta0*(L(+1))^(1+zeta)/(1+zeta))*Y(+1)/Y*pi(+1)*(pi(+1)-1);
% 4
Y=A*(K(-1)/alphaK)^(alphaK)*(M/alphaM)^(alphaM)*(L/alphaL)^(alphaL);
% 5
ebar*M*alphaK=alphaM*rk*K(-1);
% 6
w*L*alphaK=alphaL*rk*K(-1);
% 7
K=I+(1-delta)*K(-1);
%  8
EX=ebar^phi*ystar;
%  9
w=zeta0*L^zeta;
% 10
R=(1+rd(-1))/pi;
beta*(C-zeta0*L^(1+zeta)/(1+zeta) )/(C(+1)-zeta0*(L(+1))^(1+zeta)/(1+zeta))*( (rk(+1)+(1-delta)*Q(+1))/(Q+nh*Kh))=1;
% 11
beta*(C-zeta0*L^(1+zeta)/(1+zeta) )/(C(+1)-zeta0*(L(+1))^(1+zeta)/(1+zeta))*R(+1)=1;
% 12
Q=1+kappai*(I/I_ss-1)^2/2+kappai*(I/I_ss)*(I/I_ss-1);
% 13
tauN*N=taustar*ebar*Dstar+tauK*Q*Kb;
% 16
Omega=beta*(C-zeta0*L^(1+zeta)/(1+zeta) )/(C(+1)-zeta0*(L(+1))^(1+zeta)/(1+zeta))*(1-sigma+sigma*psi(+1));
mu=Omega*((rk(+1)+(1-delta)*Q(+1))/Q-(1+tauK)*R(+1));
% 17
mud=Omega*((1-taustar)*R(+1)-ebar(+1)/ebar*Rstar);
% 18
nu=Omega*R(+1)*(1+tauN);
% 19
Phi=nu/( theta*( 1+gamma*x^2/2 )-(mu+mud*x)  );
% 20
psi=theta*( 1+gamma*x^2/2 )*Phi;
% 21
x=(mu/mud)*(-1+(1+2/gamma*(mud/mu)^2)^(1/2));
% 22
Y=C+(1+kappai/2*(I/I_ss-1)^2)*I+EX+kappa/2*(pi-1)^2*Y+(nh*(Kh)^2)/2;
% 23
Dstar=Rstar(-1)*Dstar(-1)+M-EX/ebar;
% 24
N=(sigma+epsilon)*(rk+(1-delta)*Q)*Kb(-1)-sigma*R*D(-1)-sigma*Rstar(-1)*ebar*Dstar(-1);
% 25
Q*Kb=Phi*N;
% 26
Q*Kb=N+D+ebar*Dstar;
% 27
x=ebar*Dstar/(Q*Kb);
% 28
K=Kh+Kb;
% 29,
rd-steady_state(rd)=(1-rhoi)*omegapi*(pi-1)+rhoi*(rd(-1)-steady_state(rd))+e_rd;
%GDP
GDP=C+(1+(I/I_ss-1)^2/2)*I+EX-ebar*M;
%
Util=log(C-zeta0*L^(1+zeta)/(1+zeta)   );
welfare=Util+beta*welfare(+1);
% 
tauK=omega_tauK*(log(Kb)-log(steady_state(Kb)));
taustar=omega_taustar*(log(Kb)-log(steady_state(Kb)));

%%%%%%%%%%
log(A)=rho_A*log(A(-1))+e_A;
log(Rstar/Rstar_ss)=rho_Rstar*log(Rstar(-1)/Rstar_ss)+e_Rstar;
log(ystar/ystar_ss)=rho_ystar*log(ystar(-1)/ystar_ss)+e_ystar;
end;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%ģ趨%%%%%%%%%%%%%%%%%%%%%%%
%%ģг趨
shocks;
%var e_A; stderr std_A;
var e_Rstar; stderr std_Rstar;
%var e_ystar; stderr std_ystar;
%var e_rd; stderr std_rd;
end;

% Compute the steady state of the model.
steady;
% Compute the eigenvalues of the model linearized around the steady state.
check;

stoch_simul(order=2,irf=50,pruning,nograph)Y,  K,  L,  M, EX, C, I, N, D,  Dstar, GDP,ebar,  w, rk, Q,  R, rd, Rstar, Phi,  psi,  pi, x, mu, mud, Util,welfare;
oo_.mean(26)


