% bankֲ
sigma=0.94;
theta=0.474910394265250;
gamma=6.399999999999884;
epsilon=5.882352941174504e-04;
% ƫü
alphaK=0.3;
alphaL=0.55;
alphaM=0.15;
beta=1/1.015;
delta=0.02;
eta=9;
omega=0.66;
kappai=1;
zeta=0.2;
zeta0=5.89;
phi=1;
nh=9.852216748768690e-04;

x0=[0.3;1;1.02];
options = optimoptions('fsolve','TolFun',1e-15, 'MaxIter', 1e6);
[xx,fval]=fsolve(@bankss,x0,options,beta, sigma, gamma,  epsilon,theta);

x=xx(1);
Phi=xx(2);
Rb=xx(3);

xx0=[3];
options = optimoptions('fsolve','TolFun',1e-15, 'MaxIter', 1e8);
[xxx,fval]=fsolve(@nobankss,xx0,options, alphaK,  alphaL,  alphaM,   zeta0, delta,    eta,  zeta,Rb);

Y=xxx(1);

ebar=1;
rk=Rb-1+delta;
aky=(eta-1)/eta*alphaK/rk;
K=aky*Y;
L=(alphaL*rk*aky*Y/(alphaK*zeta0))^(1/(1+zeta));
M=alphaM*rk*K/(alphaK*ebar);

ystar=0.005*0.75*K*0.25/ebar+M;
nh=4*(beta*Rb-1)/K;

